package fr.polytech.ybene.bio.ui;

import fr.polytech.ybene.bio.Person;
import fr.polytech.ybene.bio.controller.ImageClickedListener;
import fr.polytech.ybene.bio.controller.ModifierListener;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

public class DisplayImg {

	// == Attributes ==
	private JPanel mainPanel;
	private JCheckBox checkBox;
	private JLabel imgDisplayer;
	private JButton btnModify;
	private ImageClickedListener imageClickedListener;
	private Person person;
	// ================

	// == Constructor ==
	public DisplayImg() {
		imageClickedListener = new ImageClickedListener(imgDisplayer, checkBox);
		imgDisplayer.addMouseListener(imageClickedListener);
	}
	// =================

	// == Getters ==
	public Person getPerson() {
		return person;
	}
	// =============

	// == Setters ==
	public void setPerson(Person person) {
		this.person = person;
		BufferedImage bufferedImage = this.person.getBuffImage();
		int size = (int) (Toolkit.getDefaultToolkit().getScreenSize().getHeight() / 3) - 100;
		Image image = bufferedImage.getScaledInstance(size, size, Image.SCALE_SMOOTH); // scale it the smooth way
		ImageIcon imageIcon = new ImageIcon(image); // transform it back
		imgDisplayer.setIcon(imageIcon);
		imageClickedListener.setPerson(person);
	}
	// =============

	// == Methods ==
	public boolean isSelected() {
		return checkBox.isSelected();
	}

	public void deselect() {
		checkBox.setSelected(false);
	}

	public void setModifyActionListener(ModifierListener modifierListener) {
		if (btnModify.getActionListeners().length >= 1) {
			btnModify.removeActionListener(btnModify.getActionListeners()[0]);
		}
		
		btnModify.addActionListener(modifierListener);
	}
	// =============
	
	// == Black magic ==
	{
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
		$$$setupUI$$$();
	}

	/**
	 * Method generated by IntelliJ IDEA GUI Designer >>> IMPORTANT!! <<< DO NOT
	 * edit this method OR call it in your code!
	 *
	 * @noinspection ALL
	 */
	private void $$$setupUI$$$() {
		mainPanel = new JPanel();
		mainPanel.setLayout(new GridBagLayout());
		imgDisplayer = new JLabel();
		imgDisplayer.setText("");
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 5;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.anchor = GridBagConstraints.WEST;
		mainPanel.add(imgDisplayer, gbc);
		final JPanel panel1 = new JPanel();
		panel1.setLayout(new com.intellij.uiDesigner.core.GridLayoutManager(1, 2, new Insets(0, 0, 0, 0), -1, -1));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 5;
		gbc.fill = GridBagConstraints.BOTH;
		mainPanel.add(panel1, gbc);
		checkBox = new JCheckBox();
		checkBox.setText("Choisir");
		panel1.add(checkBox,
				new com.intellij.uiDesigner.core.GridConstraints(0, 0, 1, 1,
						com.intellij.uiDesigner.core.GridConstraints.ANCHOR_EAST,
						com.intellij.uiDesigner.core.GridConstraints.FILL_NONE,
						com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_SHRINK
								| com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_GROW,
						com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
		btnModify = new JButton();
		btnModify.setText("Modifier");
		panel1.add(btnModify,
				new com.intellij.uiDesigner.core.GridConstraints(0, 1, 1, 1,
						com.intellij.uiDesigner.core.GridConstraints.ANCHOR_WEST,
						com.intellij.uiDesigner.core.GridConstraints.FILL_NONE,
						com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_SHRINK
								| com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_CAN_GROW,
						com.intellij.uiDesigner.core.GridConstraints.SIZEPOLICY_FIXED, null, null, null, 0, false));
	}

	/**
	 * @noinspection ALL
	 */
	public JComponent $$$getRootComponent$$$() {
		return mainPanel;
	}
	// =================
}
